const { createElement, render, useState,useEffect,Fragment} = wp.element;
function isEmpty(obj){
    if (obj == null) return true;
    if (typeof obj === 'undefined') return true;
    if (typeof obj == 'number') return false;
    if (Array.isArray(obj) || typeof obj === 'string' || obj instanceof String) return obj.length === 0;
    for (var key in obj) if (obj.hasOwnProperty(key)) return false;
    return true;
}
const Droppable = (props) => {
	const [draggableblocks,setDraggableblocks] = useState([]);
	const [isDrag,setisDrag] = useState(false);
	const [droppableblocks,setDroppableblocks] = useState([]);
	const [draggabledivblock,setDraggabledivblock] = useState('');


	const [items,setItems] = useState([]);

	const [matches,setMatches] = useState(props.matches);

	const [draggeditems,setdraggeditems] = useState([]);
	const [drtouchMovements,setdrTouchMovements] = useState([]);
	const [dptouchMovements,setdpTouchMovements] = useState([]);

	const [draggabledivTouchMovement,setDraggabledivTouchMovement] = useState({});	
		

	const [style, setStyle] = useState([]);
	const [dpstyle, setDpstyle] = useState([]);
	
	const [answer,setAnswer] = useState([]);

	const [touchCursor,setTouchCursor] = useState({x:0,y:0});

	const [childparent,setChildparent] = useState([]);


	useEffect(()=>{
		let nitems = [...props.items];
		if(props.question && props.question['marked_answer'] && props.question['marked_answer'].length){
			props.question['marked_answer'].map((value)=>{
				if(value && typeof value !=='NaN'){
					nitems = nitems.filter(item => item != props.question.original_options[(value-1)]);
				}
			});
		}
		setItems(nitems);

		let nanswer = [];
		if(props.question && props.question['marked_answer'] && props.question['marked_answer'].length){
			props.question['marked_answer'].map((value)=>{
				if((parseFloat(value)-1) >= 0){
					nanswer.push(value-1);
				}else{
					nanswer.push(null);
				}
			});
		}
		setAnswer(nanswer);
		props.update(false,'reset');
	},[props.items,props.reset]);

	const draggablegetRef = (ref, i) => {
		if(ref){
			let ndraggableblocks = draggableblocks;
			if(!ndraggableblocks[i]){
				ndraggableblocks[i] = ref;
			}
		    setDraggableblocks(ndraggableblocks);
		}
		
  	};

  	const draggabledivgetRef = (ref) => {
		if(ref){
		    setDraggabledivblock(ref);
		}
  	};

  	

  	const droppablegetRef = (ref, i) => {
		if(ref){
			let ndroppableblocks = droppableblocks;
			if(!ndroppableblocks[i]){
				ndroppableblocks[i] = ref;
			}
		    setDroppableblocks(ndroppableblocks);
		}
		
  	};

  	const onDrop = (e,i) =>{
  		if(!isDrag)
  			return;
  		//if draggable item is being dropped in same place
  		if(childparent.index === i)
  			return;

  		let nitems = [...items];
  		let nanswer = [...answer];
  		//to prevent pushing of multiple elements in same droppable 
  		if(!nanswer[i] && nanswer[i] !== 0){
	  		nitems = nitems.filter(item => item != isDrag);
	  		let index = props.original_items.indexOf(isDrag);
	  		/*if(!isEmpty(childparent.index))
  				nanswer[childparent.index] = null;*/
  			matches.map((match,i)=>{
  				if(isEmpty(nanswer[i])){
  					nanswer[i] = null;
  				}
  			});

  			if(!isEmpty(i)){
  				nanswer[i] = index;
  			}

  			setAnswer(nanswer);
  			setItems(nitems);
  			props.update(nanswer,'changed');
  		}
  	}

  	const onDropItems = (e) =>{

  		if(childparent.source !== 'droppablediv')
  			return;
  		
  		if(!isDrag)
  			return;
  		let nitems = [...items];
  		let nanswer = [...answer];
  		
  		if(!nitems.includes(isDrag)){
  			nitems.push(isDrag);
  		}
  		
  		setItems(nitems);

  		if(!isEmpty(childparent.index))
			nanswer[childparent.index] = null;

		setAnswer(nanswer);

		props.update(nanswer,'changed');
  	}

  	let classs = 'droppable';
  	if(isDrag){
  		classs +=' active';
  	}

  	const dragging = (i) =>{
  		let rr = '';
  		if(isDrag === items[i]){
  			rr ='dragging';
  		}
  		return rr;	
  	}

	return (
		<div className="match_playground">
			<div className="match_options">
			{
				matches.map((match,i) => {
					return (
			          		<div key={i} className={"match_option " +((props.question.show_correct_answer)?((props.question.correct_indexes)?(props.question.correct_indexes && props.question.correct_indexes.length && props.question.correct_indexes.includes(i))?'question_correct':'question_incorrect':''):'')}
			          		onDrop={(e)=>{ onDrop(e,i); }} 
				          	onDragOver={(e)=>{e.preventDefault();}}
				          	ref={(e)=>{droppablegetRef(e,i);}}
			          		>
			          			<div dangerouslySetInnerHTML={{__html:match}}></div>
			          			<div className="children">
			          				{
			          					(props.original_items && answer[i] != null && props.original_items[answer[i]])?
			          					<div key={'droppablediv'+i} draggable="true"
			          					onDragStart={(e)=>{
							          		if(props.original_items[answer[i]]){
							          			setisDrag(props.original_items[answer[i]]);
							          			setChildparent({index:i,source:'droppablediv'});
							          		}
							          		
							          	}} 
							          	onDragEnd={()=>{setisDrag(false);setChildparent({});}} 
							          	
							          	onDragOver={(e)=>{e.preventDefault();}}
							          	
							          	className={dragging(i)}

							          	style={dpstyle[answer[i]]}

							          	onTouchStart={(e)=>{
						          			let ndrtouchMovements = [...drtouchMovements];
							          		draggableblocks.map((block,index)=>{
							          			let rect = block.getBoundingClientRect();
							          			ndrtouchMovements[index] = rect;
							          		});
							          		setdrTouchMovements(ndrtouchMovements);

						          			let ndptouchMovements = [...dptouchMovements];
							          		droppableblocks.map((block,index)=>{
							          			let rect = block.getBoundingClientRect();
							          			ndptouchMovements[index] = rect;
							          		});
							          		setdpTouchMovements(ndptouchMovements);

							          		
							          		setDraggabledivTouchMovement(draggabledivblock.getBoundingClientRect());

							          		if(props.original_items[answer[i]]){
							          			setisDrag(props.original_items[answer[i]]);
							          			setChildparent({index:i,source:'droppablediv'});
							          		}
							          		setChildparent({});
							          		
							          	}}
							          	onTouchMove={(e)=>{
							          		if(!e)return; 
							          		e.preventDefault();
				        					if (e.type === "touchmove"){

				        						let ndpstyle =[...dpstyle];
				        						
				        						ndpstyle[answer[i]]={
				        							position:'fixed',
				        							top:Math.floor(e.touches[0].clientY)+'px',
				        							left:Math.floor(e.touches[0].clientX)+'px'
				        						};
				        						setDpstyle(ndpstyle);

				        						setTouchCursor({
				        							x:e.touches[0].clientX,y:e.touches[0].clientY });
												//setdraggeditems(nitems);
												//props.update(nitems,'changed');
							          		}
							          	}}
							          	onTouchEnd={(e)=>{
							          		
							          		//handle intermediate state and set the items on onTouchEnd
											let nitems = [...items];
										  	let nanswer = [...answer];

											if(
													(draggabledivTouchMovement.top < touchCursor.y 
													&& (draggabledivTouchMovement.top + draggabledivTouchMovement.height) > touchCursor.y) 
													&& draggabledivTouchMovement.left < touchCursor.x
													&& (draggabledivTouchMovement.left + draggabledivTouchMovement.width) > touchCursor.x
													){

												//to prevent pushing of multiple elements in same droppable 
											  		
										  		//push into draggablediv and pop out the same ans
										  		nitems.push(isDrag);
										  		nanswer.map((litem,l)=>{
										  			if(litem == answer[i]){
										  				nanswer[l] = null;
										  			}
										  		});

											  	
											}
			    							setdpTouchMovements([]);
							          		setDraggabledivTouchMovement({});
							          		setisDrag(false);
							          		setDpstyle([]);
							          		setStyle([]); 
							          		setItems(nitems);



							          		setAnswer(nanswer); 
							          		props.update(nanswer,'changed');
							          		setTouchCursor({x:0,y:0});
							          	}}


			          					>
			          						<div dangerouslySetInnerHTML={{__html:props.original_items[answer[i]]}}></div>
		          						</div>
		          						:''
			          				}
			          			</div>
			          		</div>
			          	)
				})
			}
			</div>
			<div className={classs} 
			onDragOver={(e)=>{e.preventDefault();}} 
			onDrop={(e)=>{ onDropItems(e); }}
			ref={(e)=>{draggabledivgetRef(e);}} 
			>
				{
					(items && items.length)?
					items.map((item,i) => {
			          	return (
			          		<div key={'draggablediv'+i}
				          	onDragStart={(e)=>{
				          		if(items[i]){
				          			setisDrag(items[i]);
				          		}
				          		setChildparent({});
				          	}} 
				          	onDragEnd={()=>{setisDrag(false);setChildparent({});}} 
				          	
				          	onDragOver={(e)=>{e.preventDefault();}}
				          	ref={(e)=>{draggablegetRef(e,i);}} 
				          	draggable="true" 
				          	style={style[i]}
				          	onTouchStart={(e)=>{
			          			let ndrtouchMovements = [...drtouchMovements];

				          		draggableblocks.map((block,index)=>{
				          			let rect = block.getBoundingClientRect();
				          			ndrtouchMovements[index] = rect;
				          		});
				          		setdrTouchMovements(ndrtouchMovements);

			          			let ndptouchMovements = [...dptouchMovements];
				          		droppableblocks.map((block,index)=>{
				          			let rect = block.getBoundingClientRect();
				          			ndptouchMovements[index] = rect;
				          		});
				          		setdpTouchMovements(ndptouchMovements);
				          		if(item){
				          			setisDrag(item);
				          		}
				          		setChildparent({});
				          		
				          	}}
				          	onTouchMove={(e)=>{ 
				          		e.preventDefault();
	        					if (e.type === "touchmove"){

	        						let mystyle =[...style];

	        						mystyle[i]={
	        							position:'fixed',
	        							top:Math.floor(e.touches[0].clientY)+'px',
	        							left:Math.floor(e.touches[0].clientX)+'px'
	        						};
	        						setStyle(mystyle);

	        						setTouchCursor({
	        							x:e.touches[0].clientX,y:e.touches[0].clientY });
									//setdraggeditems(nitems);
									//props.update(nitems,'changed');
				          		}
				          	}}
				          	onTouchEnd={(e)=>{
				          		setStyle([]); 
				          		//handle intermediate state and set the items on onTouchEnd
								let nitems = [...items];
							  	let nanswer = [...answer];

								dptouchMovements.map((touchMovement,index)=>{
									if(
										(touchMovement.top < touchCursor.y 
										&& (touchMovement.top + touchMovement.height) > touchCursor.y) 
										&& touchMovement.left < touchCursor.x
										&& (touchMovement.left + touchMovement.width) > touchCursor.x
										){

										//to prevent pushing of multiple elements in same droppable 
									  		
								  		let j = props.original_items.indexOf(item);

								  		if(j >= 0 && !nanswer[index] && nanswer[index] !== 0){
							  				nanswer[index] = j;
							  				nitems = nitems.filter(item1 => item1 != item);
								  		}

									  	
									}
    							});
								
    							setdpTouchMovements([]);
				          		
				          		setisDrag(false);

				          		setItems(nitems);
				          		setAnswer(nanswer); 
				          		props.update(nanswer,'changed');
				          		setTouchCursor({x:0,y:0});
				          		
				          	}}
				          	className={dragging(i)}
				          	>
				          		<div dangerouslySetInnerHTML={{__html:item}}></div>
			          		</div>
			          	)
			        })
			        :''
				}
			</div>
		</div>
	)
}

export default Droppable;