const { createElement, render, useState,useEffect,Fragment} = wp.element;


const QuizPagination = (props) => {

	const [quiz,setQuiz] = useState({});
	const [currentQuestions,setCurrentQuestions] = useState([]);
	const [currentPartNo,setCurrentPartNo] = useState(1);

	useEffect(()=>{
		setQuiz(props.quiz);
		setCurrentQuestions(props.currentQuestions);
	},[props.quiz,props.currentQuestions]);
	
	

	const loadQuestion = (e,part_no)=>{
		e.preventDefault();
		if(currentPartNo === part_no)
			return;
		let ncurrentQuestions = [...currentQuestions];
		let newcurrentQuestions = [];
		
		let start_length = (part_no*quiz.question_number)-quiz.question_number;
		let end_length = part_no*quiz.question_number;
			
		for(let i=start_length;i<end_length;i++){
			newcurrentQuestions.push(i);
		}
		setCurrentQuestions(newcurrentQuestions);
		props.update(newcurrentQuestions,'show');
		setCurrentPartNo(part_no);
	}

	const showpages = () => {
		let part_no = Math.ceil(quiz.meta.questions.length/quiz.question_number);
		let pages = [];
		if(part_no > 1){
			while(part_no){
				if(part_no){
					let temp = part_no;
					if(currentPartNo==temp){
						pages.unshift(
							<li>
								<span onClick={(e)=>{loadQuestion(e,temp);}}>{part_no}</span>
							</li>
						);
					}else{
						pages.unshift(
							<li>
								<a href="#" onClick={(e)=>{loadQuestion(e,temp);}}>
									{part_no}
								</a>
							</li>
						)
					}
					
					part_no--;
				}
			}
		}
		return pages;
	}

	

	return (
		<div className="pagination">
			
            <ul>
			{
				(quiz && quiz.meta && quiz.meta.questions && quiz.meta.questions.length)?

				
				showpages()
				:''
			}
			</ul>
		</div>
	  
	);
}
export default QuizPagination;