const { createElement, render, useState,useEffect,Fragment} = wp.element;


const Multiple = (props) => {
	const [question,setQuestion] = useState({});

	if(props.question['marked_answer'] == 'undefined' || props.question['marked_answer'] == null){
		props.question['marked_answer'] = [];
	}

	useEffect(()=>{
		setQuestion(props.question);
	},[props.question.correct_indexes]);
	const MultipleOptions = (question) => {
		
		return question.options.map(function(option,i){
			return <div className={'question_option checkbox '+((question.show_correct_answer)?((question.correct_indexes)?(question.correct_indexes && question.correct_indexes.length && question.correct_indexes.includes(i))?'question_correct':'question_incorrect':''):'')}>

				<input type="checkbox" name={props.quiz_id+'_'+question.id} value={i} id={props.quiz_id+'_'+question.id+i}  checked={(props.question['marked_answer'] && props.question['marked_answer'].length && props.question['marked_answer'].includes(i))} 
				onChange={(e)=>{
					let nquestion = {...props.question};

					if(nquestion['marked_answer'].includes(i)){
						let index = nquestion['marked_answer'].indexOf(i);
						if (index > -1) {
						  nquestion['marked_answer'].splice(index, 1);
						}
					
					}else{
						nquestion['marked_answer'].push(i);
					}
					setQuestion(nquestion); 
					props.update(nquestion,props.index,'changed');
				}
				}

				/>
				<label for={props.quiz_id+'_'+question.id+i} dangerouslySetInnerHTML={{ __html:option}}></label>
			</div>;
		})
	}

	return (
		
	  	<Fragment>
	 		<div className="question_content" dangerouslySetInnerHTML={{ __html: (question && question.content)?question.content:'' }}></div>
	 		
	 		{
	 			(question.options && question.options.length)?
	 			<Fragment>
	 			{MultipleOptions(question)}
	 			{
		 			(!question.attempted)?
		 			<span className="resetq_answer button" onClick={(e)=>{
		 				let nquestion = {...props.question}; 
						nquestion['marked_answer'] = null; 
						setQuestion(nquestion); 
						props.update(nquestion,props.index,'changed');
					}
					}>
					<i class="fa fa-trash"></i>
					</span>
		 			:''
	 			}
	 			</Fragment>
	 			:''
	 		}
	 		
 		</Fragment>
	);
}
export default Multiple;

