const { createElement, render, useState,useEffect,Fragment} = wp.element;


const Select = (props) => {

	const [question,setQuestion] = useState({});

	useEffect(()=>{
		setQuestion(props.question);
	},[props.question]);

	const SelectOptions = (question,index) => {
		return question.options.map(function(option,i){
			return <option value={i} selected={(question.marked_answer && question.marked_answer.length && question.marked_answer[index] && parseInt(question.marked_answer[index]) === i)} dangerouslySetInnerHTML={{ __html:option}}></option>
			;
		})
	}

	const setChoice = (value,i) => {
		let nquestion = {...props.question};
		if(nquestion['marked_answer'] && nquestion['marked_answer'].length){
			nquestion['marked_answer'][i] = value; 
		}else{
			nquestion['marked_answer'] = [];
			nquestion['marked_answer'][i] = value;
		}
		
		setQuestion(nquestion); 
		props.update(nquestion,props.index,'changed');
	}

	const SelectoptionsWithReset = (question,i) => {
		return <Fragment>
			<span className={((question.show_correct_answer)?((question.correct_indexes)?(question.correct_indexes && question.correct_indexes.length && question.correct_indexes.includes(i))?'question_correct':'question_incorrect':''):'')}>

				<select name={props.quiz_id+'_'+question.id} id={props.quiz_id+'_'+question.id} onChange={(e)=>{
						setChoice(e.target.value,i); 
					}}
				>
				<option>{window.wplms_quiz_data.translations.select_option}</option>
				{SelectOptions(question,i)}
				</select>

			</span>
			{
		 		(!question.attempted)?
				<span className="resetq_answer button" onClick={(e)=>{
					setChoice(null,i); 
				}}>
					<i class="fa fa-trash"></i>
				</span>
				:''
			}
		</Fragment>
	}

	return (
		
	  	<Fragment>
	 		{
	 			
	 			(question && question.extra_content && Array.isArray(question.extra_content))?
	 			<div className="question_content">
	 			{
	 				question.extra_content.map(function(content,i){
	 					
		 				return <Fragment>

		 				<span className="select_question_content" dangerouslySetInnerHTML={{ __html:content }}></span>

		 				{
			 				(question.options && question.options.length && i < (question.extra_content.length-1))?
			 				<Fragment>{SelectoptionsWithReset(question,i)}</Fragment>
			 				:''
				 		}
				 		</Fragment>
		 			})
	 			}
	 			</div>
	 			:''
	 		}
 		</Fragment>
	);
}
export default Select;

