const getUserMarkedAnswer = (question) => {
    let answer='';
    if(!question.type)
        return answer;
    if(!question['marked'] || question['marked'] == 'undefined')
        return answer;
    switch(question.type){
        case 'truefalse':
            if(question['marked']){
                answer = window.wplms_quiz_data.translations.true;
            }else{
                answer = window.wplms_quiz_data.translations.false;
            }
        break;
        case 'single':
        case 'survey':
            answer = question.options[parseInt(question['marked'])];
        break;
        case 'multiple':
            answer = '';
            
            var correct = question['marked'].split(',');
            if(correct.length){
                for(let i=0;i<correct.length;i++){
                    
                    answer += question.options[parseInt(correct[i])]+(((i+1) < correct.length)?' , ':'');
                }
            }
        break;
        case 'sort':
        case 'match':
        
            var correct = question['marked'].split(',');
            if(correct.length){
                for(let i=0;i<correct.length;i++){
                    if(question.original_options[(parseInt(correct[i])-1)] === 'undefined' || question.original_options[(parseInt(correct[i])-1)]==null || question.original_options[(parseInt(correct[i])-1)]==''){
                        question.original_options[(parseInt(correct[i])-1)] = '____';
                    }
                    answer += question.original_options[(parseInt(correct[i])-1)]+(((i+1) < correct.length)?' , ':'');
                }
            }
        break;
        case 'select':
            answer = '';
            
            var correct = question['marked'].split('|');
            if(correct.length){
                for(let i=0;i<correct.length;i++){
                    
                    answer += question.options[parseInt(correct[i])]+(((i+1) < correct.length)?' , ':'');
                }
            }
        break;
        case 'fillblank':
        case 'text':
        
            answer = '';
            var correct = question['marked'].split('|');
            if(correct.length){
                for(let i=0;i<correct.length;i++){
                    answer += correct[i]+(((i+1) < correct.length)?' , ':'');
                }
            }
        break;
        case 'largetext':
        case 'smalltext':
            answer = question['marked'];
            
        break;
    }
    return answer;
}

export default getUserMarkedAnswer;